export var ESPSDK = {};

/*** ESP CODE ***/

/**
 * This class holds information about the currently logged in user, if any.
 *
 * @constructor
 */
ESPSDK.EspPrincipal = function () {
    this._username = 'jsmith';
    this.firstName = 'John';
    this.lastName = 'Smith';
    this.label = 'John Smith';
}

/**
 * Return the end-user's username (login name).
 *
 * This field may be <code>null</code> in the case that this is an anonymous
 * session.
 *
 * Example: "aleigh"
 *
 * @returns {string}
 */
ESPSDK.EspPrincipal.prototype.getUsername = function () {
    return this._username;
}

/**
 * Return the end-user's first name.
 *
 * This field may be <code>null</code>.
 *
 * Example: "Alex"
 *
 * @returns {*}
 */
ESPSDK.EspPrincipal.prototype.getFirstName = function () {
    return this._firstName;
}

/**
 * Return the end-user's last name.
 *
 * This field may be <code>null</code>.
 *
 * Example: "Leigh"
 *
 * @returns {*}
 */
ESPSDK.EspPrincipal.prototype.getLastName = function () {
    return this._lastName;
}

/**
 * Return the end-user's display label. This is their full name, formatted properly.
 *
 * This field may NOT be <code>null</code>.
 *
 * Example: "C. Alexander Leigh"
 *
 * @returns {*}
 */
ESPSDK.EspPrincipal.prototype.getLabel = function () {
    return this._label;
}