package lc.esp.sdk;

import lc.mecha.log.MechaLogger;
import lc.mecha.log.MechaLoggerFactory;

import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageProducer;
import javax.jms.Session;

public class ESPProducer implements AutoCloseable {
    private static final MechaLogger logger = MechaLoggerFactory.getLogger(ESPProducer.class);
    private final MessageProducer producer;
    private final Session session;

    @Deprecated
    public ESPProducer(Session session, ESPAddress address) throws JMSException {
        this.session = session;
        producer = session.createProducer(address.toDestination(session));
    }

    public ESPProducer(Session session) throws JMSException {
        this.session = session;
        producer = session.createProducer(null);
    }

    @Deprecated
    public void send(ESPMessage msg) throws JMSException {
        logger.debug("Sending message... {}", msg);
        Message jms = msg.toMessage(session);
        producer.send(jms);
    }

    public void send(ESPAddress destination, ESPMessage msg) throws JMSException {
        logger.debug("Sending message... {}", msg);
        Message jms = msg.toMessage(session);
        producer.send(destination.toDestination(session), jms);
    }

    @Override
    public void close() throws Exception {
        // We leave it to ESPSession to close the session
        producer.close();
    }
}
